package jp.co.cybec.laxide.editParts;

import java.beans.PropertyChangeEvent;

import jp.co.cybec.laxide.editpolicies.LetsAjaxComponentEditPolicy;
import jp.co.cybec.laxide.editpolicies.LetsAjaxDirectEditPolicy;
import jp.co.cybec.laxide.model.base.LetsAjaxLabelModel;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.jface.viewers.TextCellEditor;

/**
 * ラベルを描画するクラス ファイル名：LetsAjaxLabelEditPart.java
 * 
 * @author nakamura 作成時刻：13:39:16
 * 
 */
public class LetsAjaxLabelEditPart extends EditPartWithListener {

	private LetsAjaxDirectEditManager directManager = null;

	/**
	 * 属性が変更された時に呼ばれるメソッド
	 * 
	 * @see jp.co.cybec.laxide.editParts.EditPartWithListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
	public void propertyChange(PropertyChangeEvent evt) {
		LetsAjaxLabelModel model = (LetsAjaxLabelModel) getModel();
		Label label = (Label) getFigure();

		// 変更の型がモデルの位置情報の変更を示すものかどうか
		if (evt.getPropertyName().equals(LetsAjaxLabelModel.P_CONSTRAINT)) {
			int textWidth = label.getTextBounds().width;
			label.getSize().width = textWidth;

			model.getConstraint().width = textWidth;
			model.getConstraint().height = 20;
			model.setComponentWidth(String.valueOf(textWidth));
			model.setComponentHeight("20");

			refreshVisuals(); // ビューを更新する
		} else if (evt.getPropertyName().equals(LetsAjaxLabelModel.P_VALUE)) {
			// モデルのテキストが変更されたのでビューに表示するテキストを更新
			label.setText((String) evt.getNewValue());

			int newTextWidth = label.getTextBounds().width;
			label.getSize().width = newTextWidth;

			model.getConstraint().width = newTextWidth;
			model.setComponentWidth(String.valueOf(newTextWidth));
		}
	}

	/**
	 * ラベルの生成
	 * 
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	protected IFigure createFigure() {
		LetsAjaxLabelModel model = (LetsAjaxLabelModel) getModel();

		Label label = new Label();
		label.setText(model.getValue());

		// 背景色を不透明に
		label.setOpaque(true);
		label.setSize(60, 50);
		return label;
	}

	protected void createEditPolicies() {
		// エディットポリシーを作成してインストール
		installEditPolicy(EditPolicy.COMPONENT_ROLE,
				new LetsAjaxComponentEditPolicy());
		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE,
				new LetsAjaxDirectEditPolicy());
	}

	protected void refreshVisuals() {
		// 制約の取得
		Rectangle constraint = ((LetsAjaxLabelModel) getModel())
				.getConstraint();

		// Rectangleオブジェクトを制約としてビューに設定する
		// setLayoutConstraintメソッドは親EditPartから呼び出す
		((GraphicalEditPart) getParent()).setLayoutConstraint(this,
				getFigure(), constraint);
	}

	public void performRequest(Request req) {
		// Requestがモデル・プロパティの直接編集を要求するものかどうか
		if (req.getType().equals(RequestConstants.REQ_DIRECT_EDIT)) {
			performDirectEdit();
			return;
		}
		super.performRequest(req);
	}

	private void performDirectEdit() {
		if (directManager == null) {
			directManager = new LetsAjaxDirectEditManager(this,
					TextCellEditor.class, new LetsAjaxCellEditorLocator(
							getFigure()));
		}
		directManager.show(); // セル・エディタの表示
	}
}
